/*

%cc1 bdsstdio.c

*/


#include "bdsstdio.h"

#define  MAXARGS   20
#define  getche    getchar


_initio()
{
    char    indevice[5] ;
    char    outdevice[5];
    char    errdevice[5];
    char    *STDIN, *STDOUT, *STDERR;
    char    cmdbuffer[128];
    char    *cmdline;
    char    *argv[MAXARGS];      /*pointers to command line arguments*/
    char    nullchar;
    char    mode[5];
    int     argc;                /*number of command line arguments*/
    int     i;
    int     count;
    FILE    *fopen();
    int     (*func)(), getchar(), putchar();
    int     program();
    int     exit();
    int     movmem();

    func= getchar;                /* Make functions get- and putchar needed */
    func= putchar;

    stdin  = 0;
    stdout = 1;
    stderr = 1;
    strcpy(indevice, "CON:");
    strcpy(outdevice,"CON:");
    strcpy(errdevice,"CON:");
    strcpy(mode,"w");
    STDIN  = indevice;
    STDOUT = outdevice;
    STDERR = errdevice;
    nullchar = NULL;
    for(i=0; i< MAXFILES; i++) _iob[i]._fd= -1; /* initialize file buffers */
    movmem(0x80, cmdbuffer, 128);
    count = cmdbuffer[0];
    cmdline = &cmdbuffer[1];
    argv[0] = &nullchar;
    argc = 1;
    while (count > 0 && argc < MAXARGS) {
        while (*cmdline == ' ' && count) {
            count--;
            cmdline++;
        }
        if (count) {
            if (*cmdline == '<') {
                STDIN = ++cmdline;
                count--;
            }
            else if (*cmdline == '>') {
                cmdline++;
                count--;
                if (*cmdline == '>') {
                    cmdline++;
                    count--;
                    mode[0] = 'a';
                }
                STDOUT = cmdline;
            }
            else {
                argv[argc] = cmdline;
                argc++;
            }
            while (*cmdline != ' ' && count) {
                cmdline++;
                count--;
            }
            *cmdline++ = '\0';
            count--;
        }
    }
    stdin =fopen(STDIN,"r");
    stdout=fopen(STDOUT,mode);
    stderr=fopen(STDERR,"w");

    program(argc,argv);

    exit(0);                     /* close all files, reboot */
}

main()
{
   _initio();
}


FILE *_getfp(name,mode)
char *name, *mode;
{
   FILE *fp;
   int  i;

   for(;;) {
     if (strcmp(name,"CON:")==0) {fp= mode[0]== 'R'? 0:1; break;}
     if (strcmp(name,"LST:")==0 && mode[0]== 'W') {fp= 2; break;}
     if (strcmp(name,"RDR:")==0 && mode[0]== 'R') {fp= 3; break;}
     if (strcmp(name,"PUN:")==0 && mode[0]== 'W') {fp= 4; break;}
     for(i=0; i< MAXFILES && _iob[i]._fd != -1; i++);
     if (i< MAXFILES) fp= &_iob[i]; else return ERROR;
     break;
   }
   return fp;
}


FILE *fopen(name,mode)
char *name, *mode;
{
   FILE *fp;
   int  _openr(), fcreat(), _opena(), (*func)();

   mode[0]= toupper(mode[0]);
   if ((fp= _getfp(name,mode))== ERROR) return ERROR;

   if (fp<0 || fp>4) {
     switch(mode[0]) {
       case 'R': func= _openr; break;
       case 'W': func= fcreat; break;
       case 'A': func= _opena; break;
       default : return ERROR;
     }
     if ((*func)(name,fp) <0) return ERROR;
   }
   return fp;
}


int _openr(name,fp)
char *name;
FILE *fp;
{
   if ((fp->_fd= open(name,0)) < 0) return ERROR;
   fp->_nleft= 0;
   return fp->_fd;
}


int _opena(name,fp)
char *name;
FILE *fp;
{
   int c;

   if ((fp->_fd= open(name,2))<0) return ERROR;
   fp->_nleft= (NSECTS * SECSIZ -1);
   fp->_nextp= fp->_buff;
   seek(fp->_fd,0,2);
   if ((c= getc(fp)) != 0x1A) putc(c,fp);
   return fp->_fd;
}


int fclose(fp)
FILE *fp;
{
   if (fp>=0 && fp<=4) return OK;
   if (fp->_nleft >0) putc(CPMEOF,fp);
   fflush(fp);
   if (close(fp->_fd)== ERROR) return ERROR;
   fp->_fd= -1;
   return OK;
}


int _allfclose()
{
   int i;

   for (i=0; i< MAXFILES; i++)
     if (_iob[i]._fd >= 0) fclose(&_iob[i]);
}


int exit(status)
int status;
{
   _allfclose();
   bdos(0); /* warmboot */
}


int getchar()
{
   return getc(stdin);
}


int getch()
{
   int c;
   if (stdin==0) {
     while ((c= bdos(6,0xff))==0);
     return c;
   }
   return getc(stdin);
}


int getc(fp)
FILE *fp;
{
   int c, nsecs;

   if (fp==0) {
     while((c= bdos(6,0xFF))==0);
     if (c=='\r') c= '\n';
     if (stdout==1) putchar(c);
     if (c==0x1A) return EOF;
       return c;
   }
   if (stdin==3) return bdos(3);
   
   if (fp->_nleft--) return *fp->_nextp++;
   if ((nsecs= read(fp->_fd, fp->_buff, NSECTS)) <= 0) return ERROR;
   fp->_nleft= (nsecs * SECSIZ -1);
   fp->_nextp= fp->_buff;
   if (*fp->_nextp == 0x1a) return EOF;
   return *fp->_nextp++;
}


int putchar(c)
int c;
{
   if (c=='\n') putc('\r',stdout);
   return putc(c,stdout);
}


int putc(c,fp)
int c;
FILE *fp;
{
   int n;

   n=0;
   if (fp==1) n= 2;
   if (fp==2) n= 5;
   if (fp==4) n= 4;
   if (n !=0) return bdos(n,c);

   if (fp->_nleft--) return *fp->_nextp++ = c;
   if ((write(fp->_fd, fp->_buff, NSECTS)) != NSECTS) return ERROR;
   fp->_nleft= (NSECTS * SECSIZ -1);
   fp->_nextp= fp->_buff;
   return *fp->_nextp++ = c;
}


int chain(s)
char *s;
{
   char *p, *l;
   p= s;
   l= 0x80;

   _allfclose();
   while (*s && *s != ' ') s++;
   if (*s) {
     strcpy(0x81, s);
     *l= strlen(s);
     *s= '\0';
   }
   exec(p);               /* discard arguments > [0] */
}


